diff --git a/web/html/index.php b/web/html/index.php
index 33c39eb..9b6874b 100644
--- a/web/html/index.php
+++ b/web/html/index.php
@@ -47,8 +47,6 @@ echo __(
 </p>
 <p>
 <?php echo __('Remember to vote for your favourite packages!'); ?>
-<br />
-<?php echo __('Some packages may be provided as binaries in [community].'); ?>
 </p>
 <table border='0' cellpadding='0' cellspacing='3' width='90%'>
 <tr>
diff --git a/web/html/pkgsubmit.php b/web/html/pkgsubmit.php
index 0f7b449..8dbfbb8 100644
--- a/web/html/pkgsubmit.php
+++ b/web/html/pkgsubmit.php
@@ -329,7 +329,7 @@ if ($_COOKIE["AURSID"]):
 				}
 
 				# Update package data
-				$q = sprintf("UPDATE Packages SET ModifiedTS = UNIX_TIMESTAMP(), Name = '%s', Version = '%s-%s', License = '%s', Description = '%s', URL = '%s', LocationID = 2, FSPath = '%s', URLPath = '%s', OutOfDate = 0 WHERE ID = %d",
+				$q = sprintf("UPDATE Packages SET ModifiedTS = UNIX_TIMESTAMP(), Name = '%s', Version = '%s-%s', License = '%s', Description = '%s', URL = '%s', FSPath = '%s', URLPath = '%s', OutOfDate = 0 WHERE ID = %d",
 					mysql_real_escape_string($new_pkgbuild['pkgname']),
 					mysql_real_escape_string($new_pkgbuild['pkgver']),
 					mysql_real_escape_string($new_pkgbuild['pkgrel']),
@@ -375,7 +375,7 @@ if ($_COOKIE["AURSID"]):
 				$uid = uid_from_sid($_COOKIE["AURSID"]);
 
 				# This is a brand new package
-				$q = sprintf("INSERT INTO Packages (Name, License, Version, CategoryID, Description, URL, LocationID, SubmittedTS, SubmitterUID, MaintainerUID, FSPath, URLPath) VALUES ('%s', '%s', '%s-%s', %d, '%s', '%s', 2, UNIX_TIMESTAMP(), %d, %d, '%s', '%s')",
+				$q = sprintf("INSERT INTO Packages (Name, License, Version, CategoryID, Description, URL, SubmittedTS, SubmitterUID, MaintainerUID, FSPath, URLPath) VALUES ('%s', '%s', '%s-%s', %d, '%s', '%s', UNIX_TIMESTAMP(), %d, %d, '%s', '%s')",
 					mysql_real_escape_string($new_pkgbuild['pkgname']),
 					mysql_real_escape_string($new_pkgbuild['license']),
 					mysql_real_escape_string($new_pkgbuild['pkgver']),
@@ -455,7 +455,6 @@ html_header("Submit");
 			endif;
 
 			$pkg_categories = pkgCategories();
-			$pkg_locations = pkgLocations();
 ?>
 
 <form action='pkgsubmit.php' method='post' enctype='multipart/form-data'>
diff --git a/web/lib/aurjson.class.php b/web/lib/aurjson.class.php
index befb639..1772c59 100644
--- a/web/lib/aurjson.class.php
+++ b/web/lib/aurjson.class.php
@@ -20,7 +20,7 @@ class AurJSON {
     private $dbh = false;
     private $exposed_methods = array('search','info');
     private $fields = array('ID','Name','Version','CategoryID','Description',
-        'LocationID', 'URL','URLPath','License','NumVotes','OutOfDate');
+        'URL','URLPath','License','NumVotes','OutOfDate');
 
     /**
      * Handles post data, and routes the request.
diff --git a/web/lib/pkgfuncs.inc b/web/lib/pkgfuncs.inc
index a4a2dfc..2fd09ec 100644
--- a/web/lib/pkgfuncs.inc
+++ b/web/lib/pkgfuncs.inc
@@ -3,7 +3,7 @@ include_once("config.inc");
 
 # define variables used during pkgsearch
 #
-$pkgsearch_vars = array("O", "L", "C", "K", "SB", "SO", "PP", "do_Orphans", "SeB");
+$pkgsearch_vars = array("O", "C", "K", "SB", "SO", "PP", "do_Orphans", "SeB");
 
 # Make sure this visitor can delete the requested package comment
 # They can delete if they were the comment submitter, or if they are a TU/Dev
@@ -80,37 +80,6 @@ function pkgCategories() {
 	return $cats;
 }
 
-# grab the current list of PackageLocations
-#
-function pkgLocations() {
-	$locs = array();
-	$dbh = db_connect();
-	$q = "SELECT * FROM PackageLocations WHERE ID != 1 AND ID < 4 ";
-	$q.= "ORDER BY Location ASC";
-	$result = db_query($q, $dbh);
-	if ($result) {
-		while ($row = mysql_fetch_row($result)) {
-			$locs[$row[0]] = $row[1];
-		}
-	}
-	return $locs;
-}
-
-# Return the repository name for a particular package.
-function package_location($name="") {
-	if (!$name) {return NULL;}
-	$dbh = db_connect();
-	$q = "SELECT PackageLocations.Location FROM Packages ";
-	$q.= "LEFT JOIN PackageLocations ON ";
-	$q.= "Packages.LocationID = PackageLocations.ID ";
-	$q.= "WHERE Name = '".mysql_real_escape_string($name)."' ";
-	$q.= "AND DummyPkg = 0";
-	$result = db_query($q, $dbh);
-	if (!$result) {return NULL;}
-	$row = mysql_fetch_row($result);
-	return $row[0];
-}
-
 # check to see if the package name exists
 #
 function package_exists($name="") {
@@ -303,9 +272,8 @@ function package_details($id=0, $SID="") {
 	$atype = account_from_sid($SID);
 	$uid = uid_from_sid($SID);
 
-	$q = "SELECT Packages.*,Location,Category ";
-	$q.= "FROM Packages,PackageLocations,PackageCategories ";
-	$q.= "WHERE Packages.LocationID = PackageLocations.ID ";
+	$q = "SELECT Packages.*,Category ";
+	$q.= "FROM Packages,PackageCategories ";
 	$q.= "AND Packages.CategoryID = PackageCategories.ID ";
 	$q.= "AND Packages.ID = " . intval($id);
 	$dbh = db_connect();
@@ -352,15 +320,13 @@ function package_details($id=0, $SID="") {
  *  request vars:
  *    O  - starting result number
  *    PP - number of search hits per page
- *    L  - package location ID number
  *    C  - package category ID number
  *    K  - package search string
  *    SO - search hit sort order:
  *          values: a - ascending
  *                  d - descending
  *    SB - sort search hits by:
- *          values: l - package location
- *                  c - package category
+ *          values: c - package category
  *                  n - package name
  *                  v - number of votes
  *                  m - maintainer username
@@ -393,8 +359,6 @@ function pkg_search_page($SID="") {
 	// grab info for user if they're logged in
 	if ($SID)
 		$myuid = uid_from_sid($SID);
-	// get a list of package locations
-	$locs = pkgLocations();
 	// get a list of package categories
 	$cats = pkgCategories(); //meow
 
@@ -433,7 +397,6 @@ function pkg_search_page($SID="") {
 	}
 	$q .= "Users.Username AS Maintainer,
 	PackageCategories.Category,
-	PackageLocations.Location,
 	Packages.Name, Packages.Version, Packages.Description, Packages.NumVotes,
 	Packages.ID, Packages.OutOfDate
 
@@ -447,15 +410,9 @@ function pkg_search_page($SID="") {
 	}
 	$q .= "LEFT JOIN PackageCategories
 	ON (Packages.CategoryID = PackageCategories.ID)
-	LEFT JOIN PackageLocations
-	ON (Packages.LocationID = PackageLocations.ID)
 	WHERE Packages.DummyPkg = 0 ";
 
-	// TODO: possibly do string matching on category and
-	//       location to make request variable values more sensible
-	if (intval($_GET["L"])) {
-		$q .= "AND Packages.LocationID = ".intval($_GET["L"])." ";
-	}
+	// TODO: possibly do string matching on category
 	if (intval($_GET["C"])) {
 		$q.= "AND Packages.CategoryID = ".intval($_GET["C"])." ";
 	}
@@ -490,27 +447,23 @@ function pkg_search_page($SID="") {
 
 	switch ($_GET["SB"]) {
 	case 'c':
-		$q.= "ORDER BY CategoryID ".$order.", Name ASC, LocationID ASC ";
+		$q.= "ORDER BY CategoryID ".$order.", Name ASC ";
 		$_GET["SB"] = 'c';
 		break;
-	case 'l':
-		$q.= "ORDER BY LocationID ".$order.", Name ASC, CategoryID DESC ";
-		$_GET["SB"] = 'l';
-		break;
 	case 'v':
 		$q.= "ORDER BY NumVotes ".$order.", Name ASC, CategoryID DESC ";
 		$_GET["SB"] = 'v';
 		break;
 	case 'm':
-		$q.= "ORDER BY Maintainer ".$order.", Name ASC, LocationID ASC ";
+		$q.= "ORDER BY Maintainer ".$order.", Name ASC ";
 		$_GET["SB"] = 'm';
 		break;
 	case 'a':
-		$q.= "ORDER BY GREATEST(SubmittedTS,ModifiedTS) ".$order.", Name ASC, LocationID ASC ";
+		$q.= "ORDER BY GREATEST(SubmittedTS,ModifiedTS) ".$order.", Name ASC ";
 		$_GET["SB"] = 'a';
 		break;
 	default:
-		$q.= "ORDER BY Name ".$order.", LocationID ASC, CategoryID DESC ";
+		$q.= "ORDER BY Name ".$order.", CategoryID DESC ";
 		break;
 	}
 
@@ -653,7 +606,7 @@ function pkg_delete ($atype, $ids) {
 		return __("You did not select any packages to delete.");
 	}
 
-	# Delete the packages in $ids array (but only if they are Unsupported)
+	# Delete the packages in $ids array
 	#
 	$dbh = db_connect();
 
@@ -671,12 +624,10 @@ function pkg_delete ($atype, $ids) {
 
 	$field = "MaintainerUID";
 
-	# Only grab Unsupported packages that "we" own or are not owned at all
+	# Only grab packages that "we" own or are not owned at all
 	$ids_to_delete = array();
-	$q = "SELECT Packages.ID FROM Packages, PackageLocations ";
+	$q = "SELECT Packages.ID FROM Packages ";
 	$q.= "WHERE Packages.ID IN (" . $delete . ") ";
-	$q.= "AND Packages.LocationID = PackageLocations.ID ";
-	$q.= "AND PackageLocations.Location = 'unsupported' ";
 
 	# If they're a TU or dev, can delete
 	if ($atype == "Trusted User" || $atype == "Developer") {
@@ -768,9 +719,8 @@ function pkg_adopt ($atype, $ids, $action = True) {
 	$q.= "WHERE ID IN ($pkg) ";
 
 	if ($action && $atype == "User") {
-		# Regular users may only adopt orphan packages from unsupported
+		# Regular users may only adopt orphan packages
 		$q.= "AND $field = 0 ";
-		$q.= "AND LocationID = 2 ";
 	} else if ($atype == "User") {
 		$q.= "AND $field = " . uid_from_sid($_COOKIE["AURSID"]);
 	}
diff --git a/web/lib/stats.inc b/web/lib/stats.inc
index 85c7e28..4f7b6ee 100644
--- a/web/lib/stats.inc
+++ b/web/lib/stats.inc
@@ -54,10 +54,10 @@ function user_table($user, $dbh)
 {
 	global $apc_prefix;
 	$escuser = mysql_real_escape_string($user);
-	$base_q = "SELECT count(*) FROM Packages,PackageLocations,Users WHERE Packages.MaintainerUID = Users.ID AND Packages.LocationID = PackageLocations.ID AND PackageLocations.Location = '%s' AND Users.Username='" . $escuser . "'";
+	$base_q = "SELECT count(*) FROM Packages,Users WHERE Packages.MaintainerUID = Users.ID AND Users.Username='" . $escuser . "'";
 
-	$maintainer_unsupported_count = db_cache_value(sprintf($base_q, 'unsupported'), $dbh,
-		$apc_prefix . 'user_unsupported_count:' . $escuser);
+	$maintainer_package_count = db_cache_value(sprintf($base_q, 'packages'), $dbh,
+		$apc_prefix . 'user_package_count:' . $escuser);
 
 	$q = "SELECT count(*) FROM Packages,Users WHERE Packages.OutOfDate = 1 AND Packages.MaintainerUID = Users.ID AND Users.Username='" . $escuser . "'";
 
@@ -74,8 +74,8 @@ function general_stats_table($dbh)
 {
 	global $apc_prefix;
 	# AUR statistics
-	$q = "SELECT count(*) FROM Packages,PackageLocations WHERE Packages.LocationID = PackageLocations.ID AND PackageLocations.Location = 'unsupported'";
-	$unsupported_count = db_cache_value($q, $dbh, $apc_prefix . 'unsupported_count');
+	$q = "SELECT count(*) FROM Packages'";
+	$package_count = db_cache_value($q, $dbh, $apc_prefix . 'package_count');
 
 	$q = "SELECT count(*) from Users";
 	$user_count = db_cache_value($q, $dbh, $apc_prefix . 'user_count');
diff --git a/web/template/pkg_details.php b/web/template/pkg_details.php
index 3677d97..46e3884 100644
--- a/web/template/pkg_details.php
+++ b/web/template/pkg_details.php
@@ -1,8 +1,8 @@
 <?php
 
 $pkgid = intval($_REQUEST['ID']);
-if ($row["Location"] == "unsupported" and ($uid == $row["MaintainerUID"] or
-	($atype == "Developer" or $atype == "Trusted User"))) {
+if ( $uid == $row["MaintainerUID"] or
+	($atype == "Developer" or $atype == "Trusted User")) {
 
 	$edit_cat = "<a href='pkgedit.php?change_Category=1&amp;ID=";
 	$edit_cat .= $pkgid ."'>".$row["Category"]."</a>";
@@ -48,7 +48,6 @@ $submitted_time = ($row["SubmittedTS"] == 0) ? "(unknown)" : gmdate("r", intval(
 	</p>
 
 	<p>
-	<span class='f3'><?php echo $row['Location'] . ' :: ' . $edit_cat ?></span><br />
 	<span class='f3'><?php echo __('Maintainer') .': ' . $maintainer ?></span><br />
 	<span class='f3'><?php echo $votes ?></span>
 	</p>
@@ -64,10 +63,8 @@ $submitted_time = ($row["SubmittedTS"] == 0) ? "(unknown)" : gmdate("r", intval(
 
 	<p><span class='f3'>
 <?php
-		if ($row['LocationID'] == 2) {
-			$urlpath = URL_DIR . $row['Name'] . '/' . $row['Name'];
-			print "<a href='$urlpath.tar.gz'>".__("Tarball")."</a> :: <a href='$urlpath'>".__("Files")."</a> :: <a href='$urlpath/PKGBUILD'>PKGBUILD</a></span>";
-		}
+        $urlpath = URL_DIR . $row['Name'] . '/' . $row['Name'];
+        print "<a href='$urlpath.tar.gz'>".__("Tarball")."</a> :: <a href='$urlpath'>".__("Files")."</a> :: <a href='$urlpath/PKGBUILD'>PKGBUILD</a></span>";
 
 		if ($row["OutOfDate"] == 1) {
 			echo "<br /><span class='f6'>".__("This package has been flagged out of date.")."</span>";
@@ -159,10 +156,8 @@ $submitted_time = ($row["SubmittedTS"] == 0) ? "(unknown)" : gmdate("r", intval(
 			else {
 				$src = $src[0];
 				# It is presumably an internal source
-				if ($row["LocationID"] == 2) {
-					echo "<a href='".dirname($row['URLPath'])."/".$row['Name'];
-					echo "/$src'>$src</a><br />\n";
-				}
+                echo "<a href='".dirname($row['URLPath'])."/".$row['Name'];
+                echo "/$src'>$src</a><br />\n";
 			}
 		}
 ?>
diff --git a/web/template/pkg_search_form.php b/web/template/pkg_search_form.php
index 567db5a..753fd0a 100644
--- a/web/template/pkg_search_form.php
+++ b/web/template/pkg_search_form.php
@@ -56,7 +56,7 @@
 						<label><?php print __("Sort by"); ?></label>
 						<select name='SB'>
 							<?php
-							$sortby = array('n' => 'Name', 'c' => 'Category', 'l' => 'Location', 'v' => 'Votes', 'm' => 'Maintainer', 'a' => 'Age');
+							$sortby = array('n' => 'Name', 'c' => 'Category', 'v' => 'Votes', 'm' => 'Maintainer', 'a' => 'Age');
 							foreach ($sortby as $k => $v):
 								if ($_REQUEST['SB'] == $k):
 							?>
diff --git a/web/template/pkg_search_results.php b/web/template/pkg_search_results.php
index bdb5f6c..48bb292 100644
--- a/web/template/pkg_search_results.php
+++ b/web/template/pkg_search_results.php
@@ -16,9 +16,6 @@
 	<?php endif; ?>
 
 	<th style='border-bottom: #666 1px solid; vertical-align: bottom'><span class='f2'>
-		<a href='?<?php print mkurl('SB=l&SO=' . $SO_next) ?>'><?php print __("Location") ?></a>
-	</span></th>
-	<th style='border-bottom: #666 1px solid; vertical-align: bottom'><span class='f2'>
 		<a href='?<?php print mkurl('SB=c&SO=' . $SO_next) ?>'><?php print __("Category") ?></a>
 	</span></th>
 	<th style='border-bottom: #666 1px solid; vertical-align: bottom'><span class='f2'>
@@ -48,7 +45,6 @@ for ($i = 0; $row = mysql_fetch_assoc($result); $i++) {
 	<?php if ($SID): ?>
 	<td class='<?php print $c ?>'><input type='checkbox' name='IDs[<?php print $row["ID"] ?>]' value='1'></td>
 	<?php endif; ?>
-	<td class='<?php print $c ?>'><span class='f5'><span class='blue'><?php print $row["Location"] ?></span></span></td>
 	<td class='<?php print $c ?>'><span class='f5'><span class='blue'><?php print $row["Category"] ?></span></span></td>
 	<td class='<?php print $c ?>'><span class='f4'><a href='packages.php?ID=<?php print $row["ID"] ?>'><span class='black'><?php print $row["Name"] ?> <?php print $row["Version"] ?></span></a></span></td>
 	<td class='<?php print $c ?>' style="text-align: right"><span class='f5'><span class='blue'><?php print $row["NumVotes"] ?></span></span></td>
diff --git a/web/template/stats/general_stats_table.php b/web/template/stats/general_stats_table.php
index 01f1fec..6c54082 100644
--- a/web/template/stats/general_stats_table.php
+++ b/web/template/stats/general_stats_table.php
@@ -6,9 +6,9 @@
 </tr>
 <tr>
 <td class='boxSoft'>
-<span class='f4'><?php print __("Packages in unsupported"); ?></span>
+<span class='f4'><?php print __("Packages"); ?></span>
 </td>
-<td class='boxSoft'><span class='f4'><?php print $unsupported_count; ?></span></td>
+<td class='boxSoft'><span class='f4'><?php print $package_count; ?></span></td>
 </tr>
 <tr>
 <td class='boxSoft'>
diff --git a/web/template/stats/user_table.php b/web/template/stats/user_table.php
index 0515868..ce75d36 100644
--- a/web/template/stats/user_table.php
+++ b/web/template/stats/user_table.php
@@ -10,10 +10,10 @@
 <tr>
 <td class='boxSoft'>
 <span class='f4'><a href="packages.php?SeB=m&amp;L=2&amp;K=<?php echo $username; ?>">
-<?php print __("Packages in unsupported"); ?></a></span>
+<?php print __("Packages"); ?></a></span>
 </td>
 <td class='boxSoft'>
-<span class='f4'><?php print $maintainer_unsupported_count; ?></span>
+<span class='f4'><?php print $maintainer_package_count; ?></span>
 </td>
 </tr>
 