Index: lib/libalpm/po/it.po
===================================================================
RCS file: /home/cvs-pacman/pacman-lib/lib/libalpm/po/it.po,v
retrieving revision 1.10
diff -u -r1.10 it.po
--- lib/libalpm/po/it.po	24 Feb 2007 20:25:45 -0000	1.10
+++ lib/libalpm/po/it.po	28 Feb 2007 16:39:35 -0000
@@ -9,7 +9,7 @@
 msgstr ""
 "Project-Id-Version: libalpm VERSION\n"
 "Report-Msgid-Bugs-To: pacman-dev@archlinux.org\n"
-"POT-Creation-Date: 2007-02-24 11:35+0100\n"
+"POT-Creation-Date: 2007-02-28 17:26+0100\n"
 "PO-Revision-Date: 2007-02-24 12:00+0100\n"
 "Last-Translator: Giovanni Scafora <linuxmania@gmail.com>\n"
 "Language-Team: Arch Linux Italian Team <linuxmania@gmail.com>\n"
@@ -17,261 +17,256 @@
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bitPlural-Forms: nplurals=2; plural=(n != 1);\n"
 
-#: lib/libalpm/add.c:95
-#, c-format
-msgid "could not parse token %s"
-msgstr "impossibile analizzare il simbolo %s"
-
-#: lib/libalpm/add.c:129
+#: lib/libalpm/add.c:75
 #, c-format
 msgid "loading target '%s'"
 msgstr "caricamento del pacchetto '%s' in corso"
 
-#: lib/libalpm/add.c:174
+#: lib/libalpm/add.c:120
 #, c-format
 msgid "replacing older version %s-%s by %s in target list"
 msgstr "sostituzione in corso della vecchia versione %s-%s con %s"
 
-#: lib/libalpm/add.c:183
+#: lib/libalpm/add.c:129
 #, c-format
 msgid "newer version %s-%s is in the target list -- skipping"
 msgstr "?? presente una versione pi?? recente di %s-%s -- verr?? ignorata"
 
-#: lib/libalpm/add.c:190
+#: lib/libalpm/add.c:136
 #, c-format
 msgid "reading '%s' metadata"
 msgstr "lettura dei metadata di '%s' in corso"
 
-#: lib/libalpm/add.c:243 lib/libalpm/remove.c:110
+#: lib/libalpm/add.c:189 lib/libalpm/remove.c:110
 msgid "looking for unsatisfied dependencies"
 msgstr "ricerca delle dipendenze non soddisfatte"
 
-#: lib/libalpm/add.c:255 lib/libalpm/sync.c:484
+#: lib/libalpm/add.c:201 lib/libalpm/sync.c:484
 msgid "looking for conflicts"
 msgstr "ricerca dei conflitti in corso"
 
-#: lib/libalpm/add.c:260
+#: lib/libalpm/add.c:206
 msgid "replacing packages with -A and -U is not supported yet"
 msgstr "la sostituzione dei pacchetti con -A e -U non ?? ancora supportata"
 
-#: lib/libalpm/add.c:261
+#: lib/libalpm/add.c:207
 #, c-format
 msgid "please remove '%s' first, using -Rd"
 msgstr "Si consiglia di rimuovere prima '%s', usando -Rd"
 
-#: lib/libalpm/add.c:302 lib/libalpm/remove.c:146
+#: lib/libalpm/add.c:248 lib/libalpm/remove.c:146
 msgid "sorting by dependencies"
 msgstr "ordinamento per dipendenze in corso"
 
-#: lib/libalpm/add.c:314
+#: lib/libalpm/add.c:260
 msgid "cleaning up"
 msgstr "pulizia in corso"
 
-#: lib/libalpm/add.c:329
+#: lib/libalpm/add.c:275
 msgid "looking for file conflicts"
 msgstr "ricerca dei conflitti tra file in corso"
 
-#: lib/libalpm/add.c:394
+#: lib/libalpm/add.c:340
 #, c-format
 msgid "upgrading package %s-%s"
 msgstr "aggiornamento del pacchetto %s-%s in corso"
 
-#: lib/libalpm/add.c:417
+#: lib/libalpm/add.c:363
 #, c-format
 msgid "adding package %s-%s"
 msgstr "inclusione del pacchetto %s-%s in corso"
 
-#: lib/libalpm/add.c:430
+#: lib/libalpm/add.c:376
 #, c-format
 msgid "removing old package first (%s-%s)"
 msgstr "rimozione del vecchio pacchetto (%s-%s) in corso"
 
-#: lib/libalpm/add.c:457
+#: lib/libalpm/add.c:403
 #, c-format
 msgid "adding %s to the NoUpgrade array temporarilly"
 msgstr "aggiunta in corso di %s nell'array temporaneo NoUpgrade"
 
-#: lib/libalpm/add.c:475
+#: lib/libalpm/add.c:421
 msgid "extracting files"
 msgstr "estrazione dei file in corso"
 
-#: lib/libalpm/add.c:490 lib/libalpm/util.c:461
+#: lib/libalpm/add.c:436 lib/libalpm/util.c:461
 msgid "could not get current working directory"
 msgstr "impossibile utilizzare la directory corrente"
 
-#: lib/libalpm/add.c:546
+#: lib/libalpm/add.c:492
 #, c-format
 msgid "%s is in NoExtract, skipping extraction"
 msgstr "%s ?? in NoExtract, estrazione ignorata"
 
-#: lib/libalpm/add.c:547
+#: lib/libalpm/add.c:493
 #, c-format
 msgid "notice: %s is in NoExtract -- skipping extraction"
 msgstr "avviso: %s ?? in NoExtract -- estrazione ignorata"
 
-#: lib/libalpm/add.c:554
+#: lib/libalpm/add.c:500
 #, c-format
 msgid "%s is in trans->skip_add, skipping extraction"
 msgstr "%s ?? in trans->skip_add, estrazione ignorata"
 
-#: lib/libalpm/add.c:600 lib/libalpm/add.c:601 lib/libalpm/add.c:750
+#: lib/libalpm/add.c:546 lib/libalpm/add.c:547 lib/libalpm/add.c:696
 #, c-format
 msgid "could not extract %s (%s)"
 msgstr "impossibile estrarre %s (%s)"
 
-#: lib/libalpm/add.c:644
+#: lib/libalpm/add.c:590
 #, c-format
 msgid "checking md5 hashes for %s"
 msgstr "controllo dell'hash md5 di %s"
 
-#: lib/libalpm/add.c:646
+#: lib/libalpm/add.c:592
 #, c-format
 msgid "checking sha1 hashes for %s"
 msgstr "controllo dell'hash sha1 di %s"
 
-#: lib/libalpm/add.c:648
+#: lib/libalpm/add.c:594
 #, c-format
 msgid "current:  %s"
 msgstr "attuale:  %s"
 
-#: lib/libalpm/add.c:649
+#: lib/libalpm/add.c:595
 #, c-format
 msgid "new:      %s"
 msgstr "nuovo:      %s"
 
-#: lib/libalpm/add.c:650
+#: lib/libalpm/add.c:596
 #, c-format
 msgid "original: %s"
 msgstr "originale: %s"
 
-#: lib/libalpm/add.c:662
+#: lib/libalpm/add.c:608
 #, c-format
 msgid "could not rename %s (%s)"
 msgstr "impossibile rinominare %s (%s)"
 
-#: lib/libalpm/add.c:663
+#: lib/libalpm/add.c:609
 #, c-format
 msgid "error: could not rename %s (%s)"
 msgstr "errore: impossibile rinominare %s (%s)"
 
-#: lib/libalpm/add.c:669 lib/libalpm/add.c:688
+#: lib/libalpm/add.c:615 lib/libalpm/add.c:634
 #, c-format
 msgid "could not copy tempfile to %s (%s)"
 msgstr "impossibile copiare il file temporaneo in %s (%s)"
 
-#: lib/libalpm/add.c:670
+#: lib/libalpm/add.c:616
 #, c-format
 msgid "error: could not copy tempfile to %s (%s)"
 msgstr "errore: impossibile copiare il file temporaneo in %s (%s)"
 
-#: lib/libalpm/add.c:674
+#: lib/libalpm/add.c:620
 #, c-format
 msgid "%s saved as %s.pacorig"
 msgstr "%s salvato come %s.pacorig"
 
-#: lib/libalpm/add.c:675
+#: lib/libalpm/add.c:621
 #, c-format
 msgid "warning: %s saved as %s"
 msgstr "attenzione: %s salvato come %s"
 
-#: lib/libalpm/add.c:685
+#: lib/libalpm/add.c:631
 #, c-format
 msgid "action: installing new file: %s"
 msgstr "azione: installazione del nuovo file %s in corso"
 
-#: lib/libalpm/add.c:695 lib/libalpm/add.c:701 lib/libalpm/add.c:706
+#: lib/libalpm/add.c:641 lib/libalpm/add.c:647 lib/libalpm/add.c:652
 msgid "action: leaving existing file in place"
 msgstr "azione: il file non ?? stato spostato"
 
-#: lib/libalpm/add.c:709
+#: lib/libalpm/add.c:655
 msgid "action: keeping current file and installing new one with .pacnew ending"
 msgstr ""
 "azione: il file attuale non ?? stato spostato e sar?? installato un nuovo file "
 "con il suffisso .pacnew"
 
-#: lib/libalpm/add.c:712
+#: lib/libalpm/add.c:658
 #, c-format
 msgid "could not install %s as %s: %s"
 msgstr "impossibile installare %s come %s: %s"
 
-#: lib/libalpm/add.c:713
+#: lib/libalpm/add.c:659
 #, c-format
 msgid "error: could not install %s as %s: %s"
 msgstr "errore: impossibile installare %s come %s: %s"
 
-#: lib/libalpm/add.c:715
+#: lib/libalpm/add.c:661
 #, c-format
 msgid "%s installed as %s"
 msgstr "%s installato come %s"
 
-#: lib/libalpm/add.c:716
+#: lib/libalpm/add.c:662
 #, c-format
 msgid "warning: %s installed as %s"
 msgstr "attenzione: %s installato come %s"
 
-#: lib/libalpm/add.c:730
+#: lib/libalpm/add.c:676
 #, c-format
 msgid "%s is in NoUpgrade -- skipping"
 msgstr "%s ?? in NoUpgrade -- verr?? ignorato"
 
-#: lib/libalpm/add.c:731
+#: lib/libalpm/add.c:677
 #, c-format
 msgid "extracting %s as %s.pacnew"
 msgstr "estrazione di %s come %s.pacnew"
 
-#: lib/libalpm/add.c:732
+#: lib/libalpm/add.c:678
 #, c-format
 msgid "warning: extracting %s as %s.pacnew"
 msgstr "attenzione: estrazione in corso di %s come %s.pacnew"
 
-#: lib/libalpm/add.c:735
+#: lib/libalpm/add.c:681
 #, c-format
 msgid "extracting %s"
 msgstr "estrazione di %s in corso"
 
-#: lib/libalpm/add.c:751
+#: lib/libalpm/add.c:697
 #, c-format
 msgid "error: could not extract %s (%s)"
 msgstr "errore: impossibile estrarre %s (%s)"
 
-#: lib/libalpm/add.c:763
+#: lib/libalpm/add.c:709
 #, c-format
 msgid "appending backup entry for %s"
 msgstr "aggiunta in corso della voce di backup per %s"
 
-#: lib/libalpm/add.c:795 lib/libalpm/add.c:797
+#: lib/libalpm/add.c:741 lib/libalpm/add.c:743
 #, c-format
 msgid "errors occurred while %s %s"
 msgstr "si sono verificati degli errori durante %s %s"
 
-#: lib/libalpm/add.c:796 lib/libalpm/add.c:798
+#: lib/libalpm/add.c:742 lib/libalpm/add.c:744
 msgid "upgrading"
 msgstr "aggiornamento in corso"
 
-#: lib/libalpm/add.c:796 lib/libalpm/add.c:798
+#: lib/libalpm/add.c:742 lib/libalpm/add.c:744
 msgid "installing"
 msgstr "installazione in corso"
 
-#: lib/libalpm/add.c:812 lib/libalpm/remove.c:321
+#: lib/libalpm/add.c:758 lib/libalpm/remove.c:321
 msgid "updating database"
 msgstr "aggiornamento del database in corso"
 
-#: lib/libalpm/add.c:813
+#: lib/libalpm/add.c:759
 #, c-format
 msgid "adding database entry '%s'"
 msgstr "inclusione della voce '%s' nel database"
 
-#: lib/libalpm/add.c:816 lib/libalpm/add.c:818
+#: lib/libalpm/add.c:762 lib/libalpm/add.c:764
 #, c-format
 msgid "could not update database entry %s-%s"
 msgstr "impossibile aggiornare la voce %s-%s nel database"
 
-#: lib/libalpm/add.c:824
+#: lib/libalpm/add.c:770
 #, c-format
 msgid "could not add entry '%s' in cache"
 msgstr "impossible includere la voce '%s' nella cache"
 
-#: lib/libalpm/add.c:852 lib/libalpm/remove.c:341 lib/libalpm/sync.c:1054
+#: lib/libalpm/add.c:798 lib/libalpm/remove.c:341 lib/libalpm/sync.c:1054
 #, c-format
 msgid "running \"ldconfig -r %s\""
 msgstr "esecuzione in corso di \"ldconfig -r %s\""
@@ -296,8 +291,8 @@
 msgid ""
 "adding new server to database '%s': protocol '%s', server '%s', path '%s'"
 msgstr ""
-"inclusione di un nuovo server nel database '%s': protocollo '%s', server "
-"'%s', path '%s'"
+"inclusione di un nuovo server nel database '%s': protocollo '%s', server '%"
+"s', path '%s'"
 
 #: lib/libalpm/alpm.c:233
 #, c-format
@@ -620,8 +615,8 @@
 msgid "db vs targs: found %s as a conflict for %s"
 msgstr "db vs targs: trovato %s come conflitto per %s"
 
-#: lib/libalpm/conflict.c:296 lib/libalpm/deps.c:57 lib/libalpm/deps.c:598
-#: lib/libalpm/deps.c:638 lib/libalpm/group.c:43 lib/libalpm/handle.c:49
+#: lib/libalpm/conflict.c:296 lib/libalpm/deps.c:57 lib/libalpm/deps.c:587
+#: lib/libalpm/deps.c:627 lib/libalpm/group.c:43 lib/libalpm/handle.c:49
 #: lib/libalpm/package.c:80 lib/libalpm/sync.c:65 lib/libalpm/sync.c:615
 #: lib/libalpm/sync.c:631 lib/libalpm/sync.c:727 lib/libalpm/trans.c:52
 #: lib/libalpm/util.c:607 lib/libalpm/util.c:614
@@ -634,30 +629,30 @@
 msgid "malloc failed: could not allocate %d bytes"
 msgstr "malloc failed: impossibile allocare %d byte"
 
-#: lib/libalpm/db.c:163
+#: lib/libalpm/db.c:167
 msgid "attempt to re-register the 'local' DB"
 msgstr "tentativo in corso di registrare di nuovo il database 'locale'"
 
-#: lib/libalpm/db.c:171
+#: lib/libalpm/db.c:175
 #, c-format
 msgid "attempt to re-register the '%s' database, using existing"
 msgstr ""
 "tentativo in corso di registrare di nuovo il database '%s', usando quello "
 "esistente"
 
-#: lib/libalpm/db.c:177
+#: lib/libalpm/db.c:181
 #, c-format
 msgid "registering database '%s'"
 msgstr "registrazione del database '%s'"
 
-#: lib/libalpm/db.c:182
+#: lib/libalpm/db.c:186
 #, c-format
 msgid "database directory '%s' does not exist -- try creating it"
 msgstr ""
 "la directory del database '%s' non esiste -- verr?? fatto un tentativo per "
 "crearla"
 
-#: lib/libalpm/db.c:193
+#: lib/libalpm/db.c:197
 #, c-format
 msgid "opening database '%s'"
 msgstr "apertura del database '%s' in corso"
@@ -674,55 +669,60 @@
 msgid "sorting dependencies finished"
 msgstr "ordinamento delle dipendenze terminato"
 
-#: lib/libalpm/deps.c:218 lib/libalpm/deps.c:275
+#: lib/libalpm/deps.c:220 lib/libalpm/deps.c:264
 msgid "null package found in package list"
 msgstr "nessun pacchetto trovato"
 
-#: lib/libalpm/deps.c:223
+#: lib/libalpm/deps.c:225
 #, c-format
 msgid "cannot find package installed '%s'"
 msgstr "impossibile trovare il pacchetto installato '%s'"
 
-#: lib/libalpm/deps.c:257 lib/libalpm/deps.c:378
+#: lib/libalpm/deps.c:245
 #, c-format
-msgid "checkdeps: found %s as required by %s"
-msgstr "checkdeps: trovato %s come richiesto da %s"
+msgid "checkdeps: updated '%s' won't satisfy a dependency of '%s'"
+msgstr "controllo delle dipendenze: il pacchetto aggiornato di '%s' non soddisfa una dipendenza di '%s'"
 
-#: lib/libalpm/deps.c:283
+#: lib/libalpm/deps.c:272
 #, c-format
 msgid "no dependencies for target '%s'"
 msgstr "nessuna dipendenza richiesta dal pacchetto '%s'"
 
-#: lib/libalpm/deps.c:329
+#: lib/libalpm/deps.c:318
 #, c-format
 msgid "missing dependency '%s' for package '%s'"
 msgstr "manca la dipendenza '%s' richiesta dal pacchetto '%s'"
 
-#: lib/libalpm/deps.c:452
+#: lib/libalpm/deps.c:367
+#, c-format
+msgid "checkdeps: found %s as required by %s"
+msgstr "controllo delle dipendenze: trovato %s come richiesto da %s"
+
+#: lib/libalpm/deps.c:441
 #, c-format
 msgid "excluding %s -- explicitly installed"
 msgstr "esclusione di %s -- installato esplicitamente"
 
-#: lib/libalpm/deps.c:499
+#: lib/libalpm/deps.c:488
 #, c-format
 msgid "cannot find package \"%s\" or anything that provides it!"
 msgstr "impossibile trovare il pacchetto \"%s\" o qualcosa che lo fornisca!"
 
-#: lib/libalpm/deps.c:508 lib/libalpm/deps.c:520
+#: lib/libalpm/deps.c:497 lib/libalpm/deps.c:509
 #, c-format
 msgid "adding '%s' to the targets"
 msgstr "inclusione in corso di '%s' nei pacchetti"
 
-#: lib/libalpm/deps.c:551
+#: lib/libalpm/deps.c:540
 msgid "started resolving dependencies"
 msgstr "avvio risoluzione delle dipendenze"
 
-#: lib/libalpm/deps.c:569
+#: lib/libalpm/deps.c:558
 #, c-format
 msgid "%s provides dependency %s -- skipping"
 msgstr "%s fornisce la dipendenza %s -- verr?? ignorato"
 
-#: lib/libalpm/deps.c:594
+#: lib/libalpm/deps.c:583
 #, c-format
 msgid ""
 "cannot resolve dependencies for \"%s\" (\"%s\" is not in the package set)"
@@ -730,27 +730,27 @@
 "impossibile risolvere le dipendenze per \"%s\" (\"%s\" non ?? presente nella "
 "lista dei pacchetti)"
 
-#: lib/libalpm/deps.c:611
+#: lib/libalpm/deps.c:600
 #, c-format
 msgid "dependency %s is already in the target list -- skipping"
 msgstr "la dipendenza %s ?? gi?? nella lista dei pacchetti -- verr?? ignorata"
 
-#: lib/libalpm/deps.c:631
+#: lib/libalpm/deps.c:620
 #, c-format
 msgid "pulling dependency %s (needed by %s)"
 msgstr "aggiunta la dipendenza %s (richiesta da %s)"
 
-#: lib/libalpm/deps.c:635
+#: lib/libalpm/deps.c:624
 #, c-format
 msgid "cannot resolve dependencies for \"%s\""
 msgstr "impossibile risolvere le dipendenze per \"%s\""
 
-#: lib/libalpm/deps.c:651
+#: lib/libalpm/deps.c:640
 #, c-format
 msgid "dependency cycle detected: %s"
 msgstr "individuato un possibile ciclo di dipendenze: %s"
 
-#: lib/libalpm/deps.c:655
+#: lib/libalpm/deps.c:644
 msgid "finished resolving dependencies"
 msgstr "risoluzione delle dipendenze terminata"
 
@@ -1036,7 +1036,7 @@
 msgid "missing package filelist in %s, generating one"
 msgstr "manca il filelist nel pacchetto %s, creazione in corso"
 
-#: lib/libalpm/package.c:546
+#: lib/libalpm/package.c:547
 #, c-format
 msgid "adding '%s' in requiredby field for '%s'"
 msgstr "inclusione di '%s' nel campo 'richiesto da' di '%s'"
@@ -1448,6 +1448,9 @@
 msgid "depcmp: %s-%s %s %s => %s"
 msgstr "depcmp: %s-%s %s %s => %s"
 
+#~ msgid "could not parse token %s"
+#~ msgstr "impossibile analizzare il simbolo %s"
+
 #~ msgid "compare versions for %s: %s vs %s, result=%d"
 #~ msgstr "confronto delle versioni di %s: %s vs %s, risultato=%d"
 
@@ -1457,9 +1460,6 @@
 #~ msgid "db scan found package: %s"
 #~ msgstr "trovato il pacchetto: %s"
 
-#~ msgid "checkdeps: found %s as a dependency for %s"
-#~ msgstr "checkdeps: trovato %s come dipendenza di %s"
-
 #~ msgid "dep is NULL!"
 #~ msgstr "dep ?? NULL!"
 