diff --git a/lib/libalpm/add.c b/lib/libalpm/add.c
index 398839a..d4912e9 100644
--- a/lib/libalpm/add.c
+++ b/lib/libalpm/add.c
@@ -177,7 +177,7 @@ int _alpm_add_prepare(pmtrans_t *trans, pmdb_t *db, alpm_list_t **data)
 
 		/* look for unsatisfied dependencies */
 		_alpm_log(PM_LOG_DEBUG, "looking for unsatisfied dependencies");
-		lp = _alpm_checkdeps(db, trans->type, trans->packages);
+		lp = alpm_checkdeps(db, trans->type, trans->packages);
 		if(lp != NULL) {
 			if(data) {
 				*data = lp;
diff --git a/lib/libalpm/alpm.h b/lib/libalpm/alpm.h
index c8f0723..301e396 100644
--- a/lib/libalpm/alpm.h
+++ b/lib/libalpm/alpm.h
@@ -353,6 +353,9 @@ typedef enum _pmdeptype_t {
 pmdepend_t *alpm_splitdep(const char *depstring);
 int alpm_depcmp(pmpkg_t *pkg, pmdepend_t *dep);
 
+alpm_list_t *alpm_checkdeps(pmdb_t *db, pmtranstype_t op,
+                             alpm_list_t *packages);
+
 const char *alpm_miss_get_target(pmdepmissing_t *miss);
 pmdeptype_t alpm_miss_get_type(pmdepmissing_t *miss);
 pmdepend_t *alpm_miss_get_dep(pmdepmissing_t *miss);
diff --git a/lib/libalpm/deps.c b/lib/libalpm/deps.c
index 8b2c32c..83f94ae 100644
--- a/lib/libalpm/deps.c
+++ b/lib/libalpm/deps.c
@@ -127,7 +127,7 @@ static alpm_list_t *_alpm_graph_init(alpm_list_t *targets)
 	for(i = vertices; i; i = i->next) {
 		pmgraph_t *vertex_i = i->data;
 		pmpkg_t *p_i = vertex_i->data;
-		/* TODO this should be somehow combined with _alpm_checkdeps */
+		/* TODO this should be somehow combined with alpm_checkdeps */
 		for(j = vertices; j; j = j->next) {
 			pmgraph_t *vertex_j = j->data;
 			pmpkg_t *p_j = vertex_j->data;
@@ -234,7 +234,7 @@ alpm_list_t *_alpm_sortbydeps(alpm_list_t *targets, pmtranstype_t mode)
  * @param packages an alpm_list_t* of packages to be checked
  * @return an alpm_list_t* of pmpkg_t* of missing_t pointers.
  */
-alpm_list_t *_alpm_checkdeps(pmdb_t *db, pmtranstype_t op,
+alpm_list_t SYMEXPORT *alpm_checkdeps(pmdb_t *db, pmtranstype_t op,
                              alpm_list_t *packages)
 {
 	alpm_list_t *i, *j, *k, *l;
@@ -658,7 +658,7 @@ int _alpm_resolvedeps(pmdb_t *local, alpm_list_t *dbs_sync, pmpkg_t *syncpkg,
 
 	_alpm_log(PM_LOG_DEBUG, "started resolving dependencies");
 	targ = alpm_list_add(NULL, syncpkg);
-	deps = _alpm_checkdeps(local, PM_TRANS_TYPE_ADD, targ);
+	deps = alpm_checkdeps(local, PM_TRANS_TYPE_ADD, targ);
 	alpm_list_free(targ);
 
 	if(deps == NULL) {
diff --git a/lib/libalpm/deps.h b/lib/libalpm/deps.h
index 59b2630..4d3132f 100644
--- a/lib/libalpm/deps.h
+++ b/lib/libalpm/deps.h
@@ -56,8 +56,6 @@ pmdepmissing_t *_alpm_depmiss_new(const char *target, pmdeptype_t type,
 																	const char *depversion);
 int _alpm_depmiss_isin(pmdepmissing_t *needle, alpm_list_t *haystack);
 alpm_list_t *_alpm_sortbydeps(alpm_list_t *targets, pmtranstype_t mode);
-alpm_list_t *_alpm_checkdeps(pmdb_t *db, pmtranstype_t op,
-                             alpm_list_t *packages);
 void _alpm_recursedeps(pmdb_t *db, alpm_list_t **targs, int include_explicit);
 int _alpm_resolvedeps(pmdb_t *local, alpm_list_t *dbs_sync, pmpkg_t *syncpkg,
                       alpm_list_t **list, pmtrans_t *trans, alpm_list_t **data);
diff --git a/lib/libalpm/remove.c b/lib/libalpm/remove.c
index a84d2b0..d315ace 100644
--- a/lib/libalpm/remove.c
+++ b/lib/libalpm/remove.c
@@ -103,7 +103,7 @@ int _alpm_remove_prepare(pmtrans_t *trans, pmdb_t *db, alpm_list_t **data)
 
 	if(!(trans->flags & PM_TRANS_FLAG_NODEPS)) {
 		_alpm_log(PM_LOG_DEBUG, "looking for unsatisfied dependencies");
-		lp = _alpm_checkdeps(db, trans->type, trans->packages);
+		lp = alpm_checkdeps(db, trans->type, trans->packages);
 		if(lp != NULL) {
 			if(trans->flags & PM_TRANS_FLAG_CASCADE) {
 				while(lp) {
@@ -121,7 +121,7 @@ int _alpm_remove_prepare(pmtrans_t *trans, pmdb_t *db, alpm_list_t **data)
 						}
 					}
 					FREELIST(lp);
-					lp = _alpm_checkdeps(db, trans->type, trans->packages);
+					lp = alpm_checkdeps(db, trans->type, trans->packages);
 				}
 			} else {
 				if(data) {
diff --git a/lib/libalpm/sync.c b/lib/libalpm/sync.c
index 8aabcdb..65159a7 100644
--- a/lib/libalpm/sync.c
+++ b/lib/libalpm/sync.c
@@ -448,7 +448,7 @@ int _alpm_sync_prepare(pmtrans_t *trans, pmdb_t *db_local, alpm_list_t *dbs_sync
 		EVENT(trans, PM_TRANS_EVT_RESOLVEDEPS_DONE, NULL, NULL);
 
 		_alpm_log(PM_LOG_DEBUG, "looking for unresolvable dependencies");
-		deps = _alpm_checkdeps(db_local, PM_TRANS_TYPE_UPGRADE, list);
+		deps = alpm_checkdeps(db_local, PM_TRANS_TYPE_UPGRADE, list);
 		if(deps) {
 			if(data) {
 				*data = deps;
@@ -658,7 +658,7 @@ int _alpm_sync_prepare(pmtrans_t *trans, pmdb_t *db_local, alpm_list_t *dbs_sync
 		}
 		if(list) {
 			_alpm_log(PM_LOG_DEBUG, "checking dependencies of packages designated for removal");
-			deps = _alpm_checkdeps(db_local, PM_TRANS_TYPE_REMOVE, list);
+			deps = alpm_checkdeps(db_local, PM_TRANS_TYPE_REMOVE, list);
 			if(deps) {
 				/* Check if broken dependencies are fixed by packages we are installing */
 				int errorout = 0;